#ifndef __DJB_WAKSMANNETWORK_HPP__
#define __DJB_WAKSMANNETWORK_HPP__

  #include "../Enclave_globals.h"
  #include <sgx_tcrypto.h>
  #include "../oasm_lib.h"
  #include "../utils.hpp"
  #include "../RecursiveShuffle/RecursiveShuffle.hpp"
  #include "../ObliviousPrimitives.hpp"
  #include "../SortingNetwork/SortingNetwork.hpp"

  void generateControlBits(uint64_t *random_permutation, size_t N, bool *controlbits);

  template <OSwap_Style oswap_style>
  void applyPermutation(bool *control_bits, size_t C, unsigned char *buffer, size_t N,
          size_t block_size);

  void DJBWaksmanShuffle(unsigned char *buffer, size_t N, size_t block_size, unsigned char *result_buffer, enc_ret *ret);

  void DecryptandDJBWaksmanShuffle(unsigned char *encrypted_buffer, size_t N, size_t encrypted_block_size, unsigned char *result_buffer, enc_ret *ret);

  /*
  void DJBWaksmanSort(unsigned char *buffer, size_t N, size_t block_size, unsigned char *result_buffer, enc_ret *ret); 

  void DJBWaksmanDecryptAndSort(unsigned char *encrypted_buffer, size_t N, size_t encrypted_block_size, unsigned char *result_buffer, enc_ret *ret); 
 */

  #include "DJBWaksman.tcc"

#endif
