
I. Instructions on how to install SGX

Refer to README.sgx.md

################################################################################

II. Instructions on how to run code

MODE/Algorithm LIST:
1  = ORShuffle (with Goodrich Compaction)
2  = ORShuffle (with ORCompact)
3  = BORPStream (lambda = -80)
4  = OddEvenMergeSort Shuffle
5  = BitonicSort Shuffle
21 = ORCompact
22 = Goodrich Compaction

The script to run our experiments need python3
  - sudo apt install python3

To run our experiments:
  - Untar artifact.tar.gz
  - In artifact_folder test that the library builds correctly by running make
  - To gather timing/OSWAP benchmarks for any of the above listed algorithms
    use run_experiments.py in Application.
  - Tweak the "CONFIGS to SET" portion of run_experiments.py to setup the
    experiment
    - Set the desired RESULTS_FOLDER 
    - Set the MODE(s) to be run, the choice of N (number of items), and
      BLOCK_SIZE (in bytes)
  - run ./run_experiments.py to run the experiments and populate the
    RESULTS_FOLDER with the output logs

NOTE: For BORPSTREAM switch the OPT_TARGET to 2 to optimize for Phase 2 time.
OPT_TARGET = 1 optimizes the total time taken.

The output folder generated by run_experiments.py can be used as we mention in
III to plot graphs out of it.

################################################################################

III. Instructions on how to recreate plots 

The folder dataplots/ provides the data we gathered from our experiments as
well as the plotter scripts used to generate the Figures in our paper.  Figures
11a, 11b, 12a, 14, and 15 are produced by plot_graph.py. Figures 11c and 12b
are produced by plot_graph_blocksizes.py.  Figure 13 is produced by
plot_parallel_data.py

The plotter scripts need python3, numpy, and matplotlib
  - sudo apt install python3
  - sudo apt install python3-numpy
  - sudo apt install python3-matplotlib

To recreate the graphs in the paper:
  - Fig 11a: Set RESULTS_FOLDER to TC_8 in plot_graphs.py and PLOT_MODE to 1
  - Fig 11b: Set RESULTS_FOLDER to TC_8 in plot_graphs.py and PLOT_MODE to 2
  - Fig 12a: Set RESULTS_FOLDER to Shuffles_8 in plot_graphs.py and PLOT_MODE
    to 3
  - Fig 14: Set RESULTS_FOLDER to TC_8 in plot_graphs.py and PLOT_MODE to 4
  - Fig 15: Set RESULTS_FOLDER to Shuffles_8 in plot_graph.py and PLOT_MODE to
    5 Run python3 plot_graphs.py

  - Fig 11c: Set RESULTS_FOLDER to TC_blocksizes in plot_graph_blocksize.py and
    PLOT_MODE to 1
  - Fig 12b: Set RESULTS_FOLDER to Shuffles_blocksizes in
    plot_graph_blocksize.py and PLOT_MODE to 2 Run python3
plot_graph_blocksize.py

To create plots on data of one's choice, run the desired experiments as
detailed in section II.  Then provide the corresponding result folder names to
the plotter scripts and setup the CONFIGS portion of the plotter script as
needed.

NOTE: Since BORPStream V1 (Phase 1 optimized) and V2 (Phase 2 optimized) share
the same MODE code of 3 Prior to plugging the output logs for V2 into the
plotter scripts we rename the output logs of those files from 3_X.lg to 33_X.lg
(X = choice of blocksize). The plotter scripts treat output logs of mode 33 as
BORPStream V2.

################################################################################
